import java.util.Vector;
import java.awt.*;

/**
 * Insert the type's description here.
 * Creation date: (22/02/2001 11:23:49)
 * @author: Administrator
 */
class subdivCurve {
	
/***********************************************************************************************/
/***********************************************************************************************/

	protected java.util.Vector controlPoints;
	protected java.util.Vector interpolatedPoints;
	protected java.util.Vector classes;
	
	protected int nbControlPoints;
	protected int nbPoints;
	protected int selectedControlPoint;
	protected int nbDecompositions;
	protected int nbIterations;	
	protected int maxClass;
	
	protected double minDetail;
	protected double maxDetail;
	
	protected boolean reSubdivide;	

	
/***********************************************************************************************/
/***********************************************************************************************/

	
/**
 * subdivCurve constructor comment.
 */
public subdivCurve() {
	super();
	
	nbControlPoints = 0;
	nbPoints = 0;
	nbDecompositions = 0;
	selectedControlPoint = -1;
	nbIterations = 0;
	
	controlPoints = new Vector();
	interpolatedPoints = new Vector();
	
	reSubdivide = true;
	
}

/***********************************************************************************************/
/***********************************************************************************************/

/**
 * Ajoute un point de control de coordonne (x,y) au polygone de control
 * Creation date: (22/02/2001 11:31:33)
 * @param x double : abscisse du point de contrle
 * @param y double : ordonne du point de contrle
 */
public boolean addControlPoint(double x, double y) {
	
	if (selectedControlPoint==-1) {
	    controlPoints.addElement(new coord2D(x,y));
	    nbControlPoints++;
	    reSubdivide = true;
	}
	
	return (selectedControlPoint==-1);
	
	}

/**
 * Mets  jours le numro du point de contrle slectionn
 * Creation date: (22/02/2001 11:34:34)
 */
public void deselectControlPoint() {
	
		selectedControlPoint = -1;
	
	}

/**
 * Selectionne le point de contrle le plus proche du point (x,y) mais dont la distance  ce point est infrieure  threshold
 * Creation date: (22/02/2001 11:44:17)
 * @return boolean : vrai si un point  t selectionn
 * @param x double : abscisse du point le plus proche
 * @param y double : ordonnee du point le plus proche
 * @param threshold double : distance maximale du point le plus proche en pixel
 */
public boolean selectCloserControlPoint(double x, double y, double threshold) {

	double d;
	double px,py;

	selectedControlPoint = -1;
	for (int i=0;i<nbControlPoints && selectedControlPoint==-1;i++) {
	    px = ((coord2D)(controlPoints.elementAt(i))).x;
	    py = ((coord2D)(controlPoints.elementAt(i))).y;
	    d = Math.sqrt((x-px)*(x-px)+(y-py)*(y-py));
	    if (d<threshold)
		selectedControlPoint = i;
	}
  
	return (selectedControlPoint!=-1);
}

/**
 * Retourne les points de contrles rangs dans un vecteur
 * Creation date: (22/02/2001 11:43:29)
 * @return java.util.Vector : les points de contrles
 */
public Vector getControlPoints() {

	Vector v;
	int x,y;

	v = new Vector();

	for(int i=0;i<nbControlPoints;i++) 	    
	    v.addElement(controlPoints.elementAt(i));

	return v;

}

/**
 * Retourne le polygone de contrle sous forme d'un polygone
 * Creation date: (22/02/2001 11:42:38)
 * @return java.util.Polygon : le polygon de contrle 
 */
public Polygon getControlPolygon() {

	Polygon pol;
	int x,y;

	pol = new Polygon();

	for(int i=0;i<nbControlPoints;i++) {
	    x = (int)(((coord2D)(controlPoints.elementAt(i))).x);
	    y = (int)(((coord2D)(controlPoints.elementAt(i))).y);
	    pol.addPoint(x,y);
	}

	return pol;
}	
	
/**
 * Dplace le point de contrle prcdemment selectionn en (x,y)
 * Creation date: (22/02/2001 11:35:31)
 * @return boolean : vrai si un point tait selectionn
 * @param x double : abscisse du point dplac
 * @param y double : ordonne du point dplac
 */
public boolean moveSelectedControlPoint(double x, double y) {
	
	if (selectedControlPoint!=-1) {
	    controlPoints.setElementAt(new coord2D(x,y),selectedControlPoint);
	    reSubdivide = true;
	}
	
	return (selectedControlPoint!=-1);
	
}

/**
 * Selectionne le point de contrle numro n
 * Creation date: (22/02/2001 11:34:03)
 * @return boolean : vrai si le point n existe
 * @param n int : le numro du point  selectionner
 */
public boolean selectControlPoint(int n) {
	
	if (nbControlPoints>=n && n>=0)
	    selectedControlPoint = n;
  
	return  (nbControlPoints>=n && n>=0);
	
}

/**
 * Met  jour la totalit des points de contrles
 * Creation date: (22/02/2001 11:30:42)
 * @param v java.util.Vector : le vecteur contenant les nouveaux points de contrle
 */
public void setControlPoints(Vector v) {
	
	nbControlPoints = v.size();
	    
	controlPoints = (Vector) v.clone();
	reSubdivide = true;
	
	}	

/**
 * Retourne le numro du point de contrle selectionn
 * Creation date: (22/02/2001 13:27:52)
 * @return int : le numro du point de contrle selectionn ou -1 si aucun points n'est selectionns
 */
public int getNumSelectedControlPoint() {
	return selectedControlPoint;
}

/**
 * Efface le point de contrle selectionn
 * Creation date: (22/02/2001 11:33:13)
 * @return boolean : vrau si un point tait selectionn
 */
public boolean removeSelectedControlPoint() {
	
	if (selectedControlPoint!=-1) {
	    for(int i=selectedControlPoint;i<nbControlPoints-1;i++)
			controlPoints.setElementAt((coord2D)(controlPoints.elementAt(i+1)),i);
	    deselectControlPoint();
	    nbControlPoints--;
	    controlPoints.setSize(nbControlPoints);
	    reSubdivide = true;
	}
	
	return (selectedControlPoint!=-1);
	
}
	

/***********************************************************************************************/
/***********************************************************************************************/
	
	/**
 * Retourne les points de la courbes subdivise
 * Creation date: (22/02/2001 11:41:24)
 * @return java.awt.Polygon : polygon constituant la courbe subdivise
 */
public Polygon getInterpolatedPolygon() {

	Polygon pol;
	int x,y;

	if (reSubdivide) {
	    subdivide(nbIterations);
	    reSubdivide = false;	    
	}         

	pol = new Polygon();
	for(int i=0;i<nbPoints;i++) {
	    x = (int)(((coord2D)(interpolatedPoints.elementAt(i))).x);
	    y = (int)(((coord2D)(interpolatedPoints.elementAt(i))).y);
	    pol.addPoint(x,y);
	}

	return pol;
	
}

/**
 * Effectue n tapes de subdivision
 * Creation date: (22/02/2001 11:37:17)
 * @param n int : nombre d'tapes de subdivision  effectuer
 */
public void subdivide(int n) {
	
	nbPoints = nbControlPoints;
	interpolatedPoints = (Vector ) controlPoints.clone();

	nbIterations = 0;

	for(int i=0;i<n;i++) 
	    subdivideOneTime();

	}

/**
 * Effectue une tape de subdivision
 * Creation date: (22/02/2001 11:36:09)
 */
public void subdivideOneTime() {

	Vector tmp;
	coord2D coord1,coord2;
	double p1,p2,p3,p4;


	/* cration d'un vecteur deux fois plus grand */
	tmp = new Vector(2*nbPoints);
	tmp.setSize(2*nbPoints);       
	
	/* on parcours tous les points de la courbes */
	for(int i=1;i<=nbPoints;i++) {
	    
	    coord1 = new coord2D();
	    coord2 = new coord2D();

	    /* on cre un nouveau point  partir de 2 anciens*/
	    p1 = ((coord2D)(interpolatedPoints.elementAt(i-1))).x;
	    p2 = ((coord2D)(interpolatedPoints.elementAt(i%nbPoints))).x;
	    p3 = ((coord2D)(interpolatedPoints.elementAt(i-1))).y;
	    p4 = ((coord2D)(interpolatedPoints.elementAt(i%nbPoints))).y;
	    
	    coord1.x = 0.75*p1 + 0.25*p2;
	    coord1.y = 0.75*p3 + 0.25*p4;
	    
	    coord2.x = 0.25*p1 + 0.75*p2;
	    coord2.y = 0.25*p3 + 0.75*p4;
	    
	    tmp.setElementAt(coord1,2*i-2);
	    tmp.setElementAt(coord2,2*i-1);
	    
	}
	
	nbIterations++;
	nbPoints = nbPoints * 2;

	interpolatedPoints = (Vector ) tmp.clone();

	}

/**
 * Supprime la dernire tape de subdivision
 * Creation date: (22/02/2001 11:38:12)
 * @return boolean : vrai si au moins une tape de subdivision avait t effectue auparavant 
 */
public boolean undoSubdivision() {

	if (nbIterations>0) {
		subdivide(nbIterations-1);
		return true;
	}
	else
		return false;
	
}	
	
	
/***********************************************************************************************/
/***********************************************************************************************/

	
/**
 * Effectue une tape de dcomposition
 * Creation date: (22/02/2001 11:39:43)
 * @return boolean : si le nombre de points taient pair et donc si la subdivision tait possible
 */
public boolean decompose() {

	Vector tmp;
	int n;
	coord2D coord1,coord2;
	double p1,p2,p3,p4;

	/* si le nombre de points est pair */
	if (nbControlPoints%2==0) {

		n = nbControlPoints/2;

		/* on duplique les points de contrle */
		tmp = (Vector) controlPoints.clone();
	    
	    for(int i=0;i<n;i++) {

	   	  coord1 = new coord2D();
		    coord2 = new coord2D();

		    /* on rcupre les 4 points ncessaire  la decomposition et on calcule les deux nouveaux points*/
				p1 = ((coord2D)(controlPoints.elementAt((2*i-2+nbControlPoints)%nbControlPoints))).x;
				p2 = ((coord2D)(controlPoints.elementAt((2*i-1+nbControlPoints)%nbControlPoints))).x;
				p3 = ((coord2D)(controlPoints.elementAt((2*i)%nbControlPoints))).x;
				p4 = ((coord2D)(controlPoints.elementAt((2*i+1)%nbControlPoints))).x;
				
				coord1.x = -0.25*p1 + 0.75*p2 + 0.75*p3 - 0.25*p4;		
				coord2.x = 0.25*p1 - 0.75*p2 + 0.75*p3 - 0.25*p4;

				p1 = ((coord2D)(controlPoints.elementAt((2*i-2+nbControlPoints)%nbControlPoints))).y;
				p2 = ((coord2D)(controlPoints.elementAt((2*i-1+nbControlPoints)%nbControlPoints))).y;
				p3 = ((coord2D)(controlPoints.elementAt((2*i)%nbControlPoints))).y;
				p4 = ((coord2D)(controlPoints.elementAt((2*i+1)%nbControlPoints))).y;
	
				coord1.y = -0.25*p1 + 0.75*p2 + 0.75*p3 - 0.25*p4;
				coord2.y = 0.25*p1 - 0.75*p2 + 0.75*p3 - 0.25*p4;

				tmp.setElementAt(coord1,i);
				tmp.setElementAt(coord2,i+n);

	    	}

	    controlPoints = (Vector ) tmp.clone();

	    nbControlPoints = n;    
	    reSubdivide = true;
	    nbDecompositions++;
	    
	    return true;

	}
	else
	    return false;

}

/**
 * Effectue une tape de reconstruction
 * Creation date: (22/02/2001 11:40:34)
 * @return boolean : vrai si au moins une dcomposition avait t effectue auparavant
 */
public boolean reconstruct() {

	Vector tmp;
	coord2D coord1,coord2;
	double p1,p2,p3,p4;

	/*si au moins une dcomposition avait t effectue auparavant*/
	if (nbDecompositions>0) {		
		
			/* on duplique les points de contrle */
			tmp =  (Vector) controlPoints.clone();
		
	    for(int i=0;i<nbControlPoints;i++) {			

 	  	  coord1 = new coord2D();
	 	    coord2 = new coord2D();

	 	    /* on rcupre les 4 points ncessaire  la reconstuction et on calcule les deux nouveaux points*/
				p1 = ((coord2D)(controlPoints.elementAt(i))).x;
				p2 = ((coord2D)(controlPoints.elementAt((i+1)%nbControlPoints))).x;
				p3 = ((coord2D)(controlPoints.elementAt(i+nbControlPoints))).x;
				p4 = ((coord2D)(controlPoints.elementAt((i+1)%nbControlPoints+nbControlPoints))).x;

				coord1.x = 0.75*p1 + 0.25*p2 + 0.75*p3 - 0.25*p4;
				coord2.x = 0.25*p1 + 0.75*p2 + 0.25*p3 - 0.75*p4; 

				p1 = ((coord2D)(controlPoints.elementAt(i))).y;
				p2 = ((coord2D)(controlPoints.elementAt((i+1)%nbControlPoints))).y;
				p3 = ((coord2D)(controlPoints.elementAt(i+nbControlPoints))).y;
				p4 = ((coord2D)(controlPoints.elementAt((i+1)%nbControlPoints+nbControlPoints))).y;

				coord1.y = 0.75*p1 + 0.25*p2 + 0.75*p3 - 0.25*p4;
				coord2.y = 0.25*p1 + 0.75*p2 + 0.25*p3 - 0.75*p4;

				tmp.setElementAt(coord1,2*i);
				tmp.setElementAt(coord2,2*i+1);

	    }

	    controlPoints = (Vector ) tmp.clone();
	    nbControlPoints = nbControlPoints*2;
	    reSubdivide = true;
	    nbDecompositions--;

		return true;
	
	}
	else
	    return false;
	    
}

/**
 * Reeffectue la dcomposition (au cas ou des points de contrles aient t modifis)
 * Creation date: (22/02/2001 11:38:48)
 * @return int : nombre d'tapes de decomposition rellement effectues (si des points ont t supprims)
 */
public int reDecompose() {
	
	int n;
	boolean ok;

	n = nbDecompositions;
	nbDecompositions=0;
	ok = true;
	while (nbDecompositions<n && ok)
	    ok = decompose();


	reSubdivide = true;
	return nbDecompositions;
	
	}

/**
 * Retourne les coefficients de dtails 
 * Creation date: (22/02/2001 11:42:07)
 * @return java.util.Vector : les coefficients de dtails
 */
public Vector getDetails() {

	Vector tmp;

	if (nbDecompositions!=0) {
	    tmp = new Vector();
	    for(int i=0;i<nbControlPoints;i++) 
		tmp.addElement(controlPoints.elementAt(i+nbControlPoints));
	    return tmp;
	}
	else
	    return null;
	    
}


/**
 * Effectue une dcomposition totale
 * Creation date: (25/02/2001 17:05:02)
 */
 public void totalDecomposition() {
 	
 	while (nbControlPoints>1)
		decompose();	
 	
 }
	
/**
 * Effectue une reconstruction totale
 * Creation date: (25/02/2001 17:05:02)
 */
 public void totalReconstruction() {
 	
		while (nbDecompositions>0)
			reconstruct();

 }	
		
		

/***********************************************************************************************/
/***********************************************************************************************/


/**
 * Calcule l'histogramme des coefficients de dtails
 * Creation date: (25/02/2001 17:05:02)
 * @param slices int : nombres de classes de l'histogramme
 * @return java.Utils.Vector : les slices classes de l'histogramme
 */
public Vector computeHistogramm(int slices) {

	Vector norms;
	double x,y,d,delta;
	int position,val;

	maxDetail = 0;
	minDetail = 0;
	classes = new Vector();
	norms = new Vector();
	
	/* si au moins une dcomposition */
	if (nbDecompositions!=0) {
	 
		/* on calcule le vector contenant les normes des coefficients de dtails et on dtermine la plus grande et la plus petite norme pour centrer l'affichage */
		x = ((coord2D)(controlPoints.elementAt(nbControlPoints))).x;
		y = ((coord2D)(controlPoints.elementAt(nbControlPoints))).y;
		d = Math.sqrt(x*x+y*y);
		norms.addElement(new Double(d));
		minDetail = d;
		maxDetail = d;
		for(int i=1;i<nbControlPoints;i++) {
			x = ((coord2D)(controlPoints.elementAt(i+nbControlPoints))).x;
			y = ((coord2D)(controlPoints.elementAt(i+nbControlPoints))).y;
			d = Math.sqrt(x*x+y*y);
			norms.addElement(new Double(d));	
			if (d<minDetail)
				minDetail = d;
			if (d>maxDetail)
				maxDetail = d;				
		}

		maxDetail += 0.01;
	
		/* on met  zero le vecteur contenant les classes*/
		for(int i=0;i<slices;i++) 
			classes.addElement(new Integer(0));
	
		norms.trimToSize();
		classes.trimToSize();
	
		/* on parcours le vecteur contenant les normes des coefficients et on met  jours le vecteur des classes*/
		delta = (maxDetail-minDetail)/slices;
		if (delta!=0) {
			for(int i=0;i<norms.size();i++) {
				d = ((Double)(norms.elementAt(i))).doubleValue();
				position = (int)((d-minDetail)/delta);
				val = ((Integer)(classes.elementAt(position))).intValue();
				classes.setElementAt(new Integer(val+1),position);
			}
			
			classes.trimToSize();
			
		}
			
	}
	else {
		/* si on avait pas fait de dcompositions on met le vecteur de classes zro*/
		classes = new Vector();
		for(int i=0;i<slices;i++) 
			classes.addElement(new Integer(0));
		minDetail = 0;
		maxDetail = 0;
		maxClass = 0;							
	}

	maxClass = 0;
	for(int i=0;i<classes.size();i++) {
		val = ((Integer)(classes.elementAt(i))).intValue();
		if (val>maxClass)
			maxClass = val;
	}
	
	return classes;
}

/**
 * Retourne la taille de la plus grande classe
 * Creation date: (25/02/2001 18:38:47)
 * @return int : la taille de la plus grande classe
 */
public int getMaxClass() {
	return maxClass;
}

/**
 * Retourne la norme du plus grand vecteur dtail
 * Creation date: (25/02/2001 18:38:47)
 * @return double : norme du plus grand vecteur dtail
 */
public double getMaxDetail() {
	return maxDetail;
}

/**
 * Retourne la norme du plus petit vecteur dtail
 * Creation date: (25/02/2001 18:38:47)
 * @return double : norme du plus petit vecteur dtail
 */
public double getMinDetail() {
	return minDetail;
}


/***********************************************************************************************/
/***********************************************************************************************/


/**
 * Effectue une dcomposition totale de la courbe, elimine les threshold % plus petit coefficients de dtails, et effectue une reconstruction totale 
 * Creation date: (25/02/2001 18:38:47)
 * @return void
 */
public void compress(double threshold) {
	
	coord2D c2d;
	int n,indiceMin;
	double min,d;
	
	/* on effectue une dcomposition totale*/
		totalDecomposition();	
	
	/* nombre de coefficients de dtails  mettre  zro*/
	n = (int)((controlPoints.size()-1)*threshold/100.0);
	
	/* parmi les coefficients de details, on met  zro n fois le plus petit coefficient de details (bien sur different de 0)*/
	for(int j=0;j<n;j++) {
		min = Double.MAX_VALUE;
		indiceMin = 0;
		for(int i=1;i<controlPoints.size();i++) {
			c2d = (coord2D)(controlPoints.elementAt(i));
			d = Math.sqrt(c2d.x*c2d.x+c2d.y*c2d.y);
			if (d!=0 && d<min) {
				min = d;
				indiceMin = i;		
			}						
		}

		controlPoints.setElementAt(new coord2D(0,0),indiceMin);
	}
			
	/* on effectue une reconstructiontion totale*/
		totalReconstruction();
	
}


/***********************************************************************************************/
/***********************************************************************************************/


}